// Code generated by genpjrpc. DO NOT EDIT.
//  genpjrpc version: v0.1.0

package rpcserver

import (
	"context"
	"encoding/json"
	"fmt"

	pjrpc "gitlab.com/pjrpc/pjrpc/v2"
	"gitlab.com/pjrpc/pjrpc/v2/pjson"

	"middlewares/service"
)

// List of the server JSON-RPC methods.
const (
	JSONRPCMethodMethod    = "method"
	JSONRPCMethodExclusive = "exclusive"
)

// ServiceServer is an API server for Service service.
type ServiceServer interface {
	Method(ctx context.Context, in *service.In) (service.Out, error)
	Exclusive(ctx context.Context, in *service.In) (service.Out, error)
}

type regService struct {
	svc ServiceServer
}

// RegisterServiceServer registers rpc handlers with middlewares in the server router.
func RegisterServiceServer(srv pjrpc.Registrator, svc ServiceServer, middlewares ...pjrpc.Middleware) {
	r := &regService{svc: svc}

	srv.RegisterMethod(JSONRPCMethodMethod, r.regMethod)
	srv.RegisterMethod(JSONRPCMethodExclusive, r.regExclusive)

	srv.With(middlewares...)
}

func (r *regService) regMethod(ctx context.Context, params json.RawMessage) (interface{}, error) {
	in := new(service.In)
	if params != nil {
		if err := pjson.Unmarshal(params, in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.Method(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed Method: %w", err)
	}

	return res, nil
}

func (r *regService) regExclusive(ctx context.Context, params json.RawMessage) (interface{}, error) {
	in := new(service.In)
	if params != nil {
		if err := pjson.Unmarshal(params, in); err != nil {
			return nil, pjrpc.JRPCErrParseError("failed to parse params")
		}
	}

	res, err := r.svc.Exclusive(ctx, in)
	if err != nil {
		return nil, fmt.Errorf("failed Exclusive: %w", err)
	}

	return res, nil
}
